/* This file is part of Error Correctiong Codes Application.
 *
 * Ecc-Application is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Ecc-Application is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ecc-Application; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
 

package ch.educeth.eccapplet;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


/** 
 * Diese Klasse kuemmert sich um das Aussehen und Verhalten der 
 * Generatormatrix */
public class EccGeneratorFrame {
	private JDialog dialog;
	private int dimension;
	private JPanel buttonPanel;
	private JPanel mainPanel;
	final JButton[] buttonArray;
	final int[][] value;
	private JButton change;
	private String str1 = "", str2 = "";
	
	public EccGeneratorFrame(int dim) {
		JFrame dummy = new JFrame();
		dimension = dim;
		buttonArray = new JButton[2*dim];
		value = new int[2][dim];
		dialog = new JDialog(dummy, EccConstants.GENERATOR_MATRIX, true);
		dialog.getContentPane().setLayout(new FlowLayout());
		mainPanel = new JPanel();
		mainPanel.setLayout(new BoxLayout(mainPanel, BoxLayout.Y_AXIS));
		buttonPanel = new JPanel();
		buttonPanel.setLayout(new GridLayout(2, dimension));
		String str3 = EccController.CONTROLLER.ecmo.getFirstString();
		String str4 = EccController.CONTROLLER.ecmo.getSecondString();
		for (int i = 0; i < 2*dim; i++) {
			if (EccController.CONTROLLER.ecmo.getModifiedFlag()) {
				if (i < dimension) {
					buttonArray[i] = new JButton(String.valueOf(str3.charAt(i)));
					value[0][i] = Integer.valueOf(String.valueOf(str3.charAt(i))).intValue();
				} else {
					buttonArray[i] = new JButton(String.valueOf(str4.charAt(i - dimension)));
					value[1][i - dimension] = Integer.valueOf(String.valueOf(str4.charAt(i - dimension))).intValue();
				}	
			} else if (EccController.CONTROLLER.ecmo.getGeneratorFlag()) {
				String str20 = "", str21 = "";
				if (dim == 13) {
					str20 = EccColorModel.GENERATOR131;
					str21 = EccColorModel.GENERATOR132;
				} else if (dim == 7) {
					str20 = EccColorModel.GENERATOR71;
					str21 = EccColorModel.GENERATOR72;
				} else if (dim == 6) {
					str20 = EccColorModel.GENERATOR61;
					str21 = EccColorModel.GENERATOR62;
				} else if (dim == 5) {
					str20 = EccColorModel.GENERATOR51;
					str21 = EccColorModel.GENERATOR52;
				} else if (dim == 4) {
					str20 = EccColorModel.GENERATOR41;
					str21 = EccColorModel.GENERATOR42;
				} else if (dim == 3) {
					str20 = EccColorModel.GENERATOR31;
					str21 = EccColorModel.GENERATOR32;
				} else {
				}
				if (i < dimension) {
					buttonArray[i] = new JButton(String.valueOf(str20.charAt(i)));
					value[0][i] = Integer.valueOf(String.valueOf(str20.charAt(i))).intValue();
				} else {
					buttonArray[i] = new JButton(String.valueOf(str21.charAt(i - dimension)));
					value[1][i - dimension] = Integer.valueOf(String.valueOf(str21.charAt(i - dimension))).intValue();
				}	
								
			} else {
				buttonArray[i] = new JButton("0");
			}
			buttonArray[i].setActionCommand(String.valueOf(i));
			buttonArray[i].addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					int place = Integer.valueOf(e.getActionCommand()).intValue();
					int div = place/dimension;
					int mod = place%dimension;
					if (value[div][mod] == 0) {
						value[div][mod] = 1;
						buttonArray[place].setText("1");
					} else {
						value[div][mod] = 0;
						buttonArray[place].setText("0");
					}
				}
			});
			buttonPanel.add(buttonArray[i]);
		}
		mainPanel.add(buttonPanel);
		mainPanel.add(Box.createRigidArea(new Dimension(0,10)));
		change = new JButton(EccConstants.MATRIX_ACCEPT);
		change.setAlignmentX(Container.CENTER_ALIGNMENT);

		change.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				/* calculate the 4 codewords */
				for (int i = 0; i < dimension; i++) {
					EccController.CONTROLLER.ecmo.setMatrixAt(0, i, 0);
				}
				for (int i = 0; i < dimension; i++) {
					int temp = (0*value[0][i] + 1*value[1][i]) % 2;
					EccController.CONTROLLER.ecmo.setMatrixAt(1, i, temp);
				}
				for (int i = 0; i < dimension; i++) {
					int temp = (1*value[0][i] + 0*value[1][i]) % 2;
					EccController.CONTROLLER.ecmo.setMatrixAt(2, i, temp);
				}	
				for (int i = 0; i < dimension; i++) {
					int temp = (1*value[0][i] + 1*value[1][i]) % 2;
					EccController.CONTROLLER.ecmo.setMatrixAt(3, i, temp);
				}
				for (int i = 0; i < dimension; i++) {
					str1 += value[0][i];
					str2 += value[1][i];
				}
				EccController.CONTROLLER.ecmo.setModifiedString(str1, str2);
				EccController.CONTROLLER.ecmo.setModifiedFlag(true);
				EccController.CONTROLLER.ecmo.setGeneratorFlag(true);
				EccController.CONTROLLER.ecmo.setHyperOriginalColor(dimension);
				EccController.CONTROLLER.emep.setErrorProbability(
					EccController.CONTROLLER.emep.getErrorProbability());
				dialog.dispose();
			}
		});
		
		mainPanel.add(change);
		dialog.getContentPane().add(mainPanel);
		dialog.setResizable(false);
		dialog.pack();
		dialog.show();

		dialog.addWindowListener (new WindowAdapter() {
			public void windowClosing( WindowEvent e ) {
				dialog.dispose();
			}
		});

	}
	
}
